package dienst;
import java.util.*;
import org.w3c.dom.*;
import org.xml.sax.*;


public class ListIdentifiers extends Response{
    String partition;
    String resumptionToken=null;
    public ListIdentifiers(DataProvider dp){
        super(dp);
    }


    public void  read(String set,String file_after,String file_before)throws java.io.IOException{
	String s;
    partition=set;
	if (partition==null)
	    s="";
	else
	    s="set="+URIEncoder.encode(partition);

	if (file_after!=null){
	    if (s!="")
		s=s+"&from="+file_after;
	    else
		s="from="+file_after;
	}

    if (file_before!=null){
	    if (s!="")
		s=s+"&until="+file_before;
	    else
		s="until"+file_before;
	}


    read(dp.m_url+"?verb=ListIdentifiers&"+s);

	}

    public Result parse() throws dienst.ParseException,java.io.IOException{
            RecordList recordList=new RecordList();

            if (resumptionToken!=null){
                read(dp.m_url+"?verb=ListIdentifiers&resumptionToken="+URIEncoder.encode(resumptionToken));
            }
            resumptionToken=null;

            Element e= super.validate();

            NodeList n=e.getChildNodes();
            if (n==null)
                return recordList;
            Node recordElement=null;

            //find oams record
            String errorReport="";
            for (int i=0;i<n.getLength();i++){
                recordElement=n.item(i);
                if (recordElement.getNodeType()==Node.ELEMENT_NODE)
                   if (((Element)recordElement).getTagName().equals("identifier")){
                                Record r=new Record();
                                r.m_id=MetaParser.fetchChild ((Element)recordElement);
				  
				if (partition!=null)
				    r.m_sets=dp. m_partitionList.getSpecByName(partition);
				
                                r.m_archive=dp.m_id;
                                recordList.add(r);
                    }//end if
                    else if (((Element)recordElement).getTagName().equals("resumptionToken")){
                        resumptionToken= MetaParser.fetchChild((Element)(recordElement));
                    }
            } //end for
        return recordList;
    }

    public String getResumptionToken(){
        return resumptionToken;
    }

}
