package interactive.createSubject;
import java.sql.*;
import java.io.*;

import java.net.*;
import java.util.*;
import db.*;

public class CreateDB {
    Connection connection=null;
    DB db=null;
    Statement stmt;
    TreeSet treeset=new TreeSet();


    public void run(ConnectionPool cpool){
	try {
	    connection=cpool.getConnection();
	    db=new DB(connection);
	    stmt = connection.createStatement();
	    collect();
	    stmt.close();
	    cpool.close(connection);
        } catch (SQLException sqle){
            System.out.println(sqle);
	} catch (Exception e){
            System.out.println(e);
        }
    }


    private void collect(){
             String query="delete from dcnew";
      try{
           
            
	  stmt.executeQuery(query);
           for (Enumeration enum=db.archives.keys ();enum.hasMoreElements() ;) {
                String archive=(String)(enum.nextElement());
            

                Hashtable fieldhash=(Hashtable)(db.archives.get(archive));
   
                for (Enumeration field=fieldhash.keys();field.hasMoreElements();){
                    String fieldname=(String)(field.nextElement());
                    TreeSet detail=(TreeSet)(fieldhash.get(fieldname));

                        for(Iterator itr=detail.iterator();itr.hasNext();){
                              String subject=(String)(itr.next());
                             String padSubject=padSpecialChar(subject);
                            String query2="insert into dcnew values('" + archive + "',' "
+ padSubject + "')";
			    try{
				stmt.executeQuery(query2);
			    }
			    catch(Exception e){
			    }
                          }
                     }
              }
           }catch (Exception e){
                                System.out.println(e);
            }
    }

public String padSpecialChar(String input) {
  if ( input==null)
  {
    return null;
  }
 StringBuffer buffer=new StringBuffer();
       for ( int i=0;i<input.length();i++)
       {
             if ( input.charAt(i) == '\'')
             {
                 buffer.append("\"");
             }else
            {
               buffer.append(input.charAt(i));
            }
       }
  return buffer.toString();
}

}


