package log;

import dienst.Result;

import java.util.*;
import java.text.*;

public class LogRecord implements Result {
    public Date m_inputdate=Calendar.getInstance().getTime();
    public String m_operation=""; 
    public String m_source="";
    public String m_destination="";
    public String m_status="Sending";
    public int m_totalnum=0;
    public String m_detail="";
    public boolean m_updateharvesttime=false;

    public LogRecord(Date inputdate, String operation, String source, String destination, boolean updateharvesttime) {
	m_inputdate = inputdate;
	m_operation = operation;
	m_source = source;
	m_destination = destination;
	m_updateharvesttime = updateharvesttime;
    }

    public String toString() {
	String temp = "inputdate = " + m_inputdate + " operation=" + m_operation + " source= " + m_source + " destination=" + m_destination + "status=" + m_status + "totalnum=" + Integer.toString(m_totalnum) + " detail = " + m_detail;
	return temp;
    }

}
