package ns.ldap;
// This class is used to collect Information of Each  user who match the query in the Name Server.

import java.io.*;
import java.text.*;
import java.net.*;
import java.util.*;

import ns.*;

class User extends DPName
{
    public String LastLogin;
    public String LastLogout;
    public String RegisterTime;

    User()
    {
       id = new String();
       baseURL = new String();
       LastLogin = new String();
       LastLogout = new String();
       RegisterTime = new String();
       harvestMethod="fresh_mass";
    }

   public void Fill( String iUserName, String ibaseURL, boolean status,
                     String iLastLogin, String iLastLogout, String iRegisterTime)
   {
       id = iUserName;
       baseURL=ibaseURL;
       active = status;
       LastLogin = iLastLogin;
       LastLogout = iLastLogout;
       RegisterTime = iRegisterTime;
   }

   public void Print()
   {
      System.out.println("\n\n\n\nUser Name     : "+id);
      System.out.println("baseURL          : "+baseURL);
      System.out.println("status        : "+active);
      System.out.println("Last Login    : "+LastLogin);
      System.out.println("Last Logout   : "+LastLogout);
      System.out.println("Register Time : "+RegisterTime);
   }

}