package scheduler;


import java.util.*;
import dienst.*;
import log.*;

public class HarvestListAddAll extends HarvestByPartition{
    public HarvestListAddAll(DataProvider dp,Record2DB oo, Log m_log){
        super(dp,oo, m_log);
    }
// read partition

    public boolean forever(){
        return false;
    }
    public void run() throws ParseException,java.io.IOException{
	if (enum.hasMoreElements()) {
               String partitionname=(String)(enum.nextElement());
	       if (partitionname.equals (FAKEFLAG))
                    partitionname=null;
               else
		   System.out.println("Harvesting set: "+ partitionname);
	       // Date d=new Date();
	       /* if (dp.getSet() == null || dp.getSet().length() ==0 || ((partitionname != null) && (partitionname.equals(dp.getSet())))) {
	       **/


   	       Enumeration metafm = mfList.elements();
               while (metafm.hasMoreElements()){  
                   m_logrecord = new LogRecord(Calendar.getInstance().getTime(),"HarvestListAddAll",dp.getId(),"MAIN", true);
	           m_log.writeBeginLog(m_logrecord);
 	   
		   String metaFormat = (String)metafm.nextElement();
                   System.out.println("Start harvesting "+metaFormat + " .....");    
		   dp.listRecords.read(partitionname,null,null,metaFormat);

		   int totalsize = 0;

		   do{              
                       MetadataList m_mlist = dp.listRecords.preParse(); 
                       totalsize = totalsize+(m_mlist==null?0:m_mlist.size());
                       oo.add(m_mlist); //Store matadata into database
                                       
		       /* RecordList m_list = (RecordList)dp.listRecords.parse();
		       totalsize = totalsize + (m_list==null?0:m_list.size());

		       oo.add(dp.m_id,m_list); */
                       
		       try{
			   Thread.sleep(Config.SLEEP_BETWEEN_REQUEST);
		       }
		       catch(Exception e){
			   System.out.println(e);
		       }
		    } while(dp.listRecords.getResumptionToken()!=null);

		   m_logrecord.m_status = "OK";
		   m_logrecord.m_detail = dp.getUrl() + "?verb=ListRecords";
		   m_logrecord.m_totalnum = totalsize;
		   m_log.writeEndLog(m_logrecord,dp.getId());

                   System.out.println("End of "+metaFormat + "harvest");
                }
       }
	else{
	   done=true;
           oo.updateHarvestmethod(dp.m_id);
	}
    }

    public String toString(){
        return (dp.m_id + " HarvestListAddAll "+ Clock.startDate ());
    }
}




