package ns;
import java.util.Date;
/**
 * Detail information about data provider
 * this information is used by search engine and service provider interface
 */

public class DPName implements Comparable  {
    public String id;
    public String baseURL;
    public boolean active;
    public String harvestMethod;
    public String sets;
    public String lastharvesttime;
    public String resumptionToken;
    public String metaFormat;
    public String oaiversion;
    /** Returns the provider details in a string form*/
    public String toString(){
        return "id="+id+";harvestURL="+baseURL+";sets="+sets+";active="+active+";harvestMethod="+harvestMethod + ";lastharvesttime=" + lastharvesttime +";metaFormat=" + metaFormat +";oaiversion=" + oaiversion;
    } 
    /** used to compare providers by their ids. */
    public int compareTo(Object o){
	DPName dp=(DPName)o;
	return id.compareToIgnoreCase(dp.id);
    }

}
