package oairequester;
import java.util.*;
import org.xml.sax.*;
import org.w3c.dom.*;

public class ListSets extends Response{
    public ListSets(DataProvider dp){
        super(dp);
    }

    public void read() throws java.io.IOException{
        read(dp.m_url+"?verb=ListSets");
    }

    public Result parse()throws java.io.IOException,oairequester.ParseException{
        Element root= super.validate();
        PartitionList pList=new PartitionList();

        NodeList nl= root.getChildNodes();
        for(int i=0;i<nl.getLength();i++)
            if (nl.item(i).getNodeType()==Node.ELEMENT_NODE)
            {
               Element partitionElement=(Element)(nl.item(i));
               if (partitionElement.getTagName().equals("set")){
                    NodeList childnl=partitionElement.getChildNodes();
                    Element childElement=null;
                    Partition p=null;
                    String spec=null;
                    String name=null;
                    for (int j=0;j<childnl.getLength();j++){
                         if (childnl.item(j).getNodeType()==Node.ELEMENT_NODE){
                           childElement=(Element)childnl.item(j);
                           if (childElement.getTagName().equals("setSpec")){
                                    spec=MetaParser.fetchChild (childElement);
                            }
                            else if (childElement.getTagName().equals("setName")){
                                name=MetaParser.fetchChild (childElement);
                             }
                         }//end if
                    }//end for

                    pList.add(spec,name);
               }//endif
            }//endif
	dp.m_partitionList=pList;
        return pList;

    }//end parse
}
