package parser;
import java.io.*;
import java.util.*;
import java.lang.*;
import java.text.*;

public class DateNormalizer
{ 
    private Hashtable list = new Hashtable();
    Date today = null;
    String thisYear=null;
    public DateNormalizer() {   
  
        list.put("JAN", "01");
        list.put("FEB", "02");
        list.put("MAR", "03");
        list.put("APR", "04");
        list.put("MAY", "05");
        list.put("JUN", "06");
        list.put("JUL", "07");
        list.put("AUG", "08");
        list.put("SEP", "09");
        list.put("OCT", "10");
        list.put("NOV", "11");
        list.put("DEC", "12");
        
        Calendar rightNow = Calendar.getInstance();
		today = rightNow.getTime();
        SimpleDateFormat formatter = new SimpleDateFormat("yyyy");
        thisYear = formatter.format(today);
    }
       
    public String format(String dates){
    	String year="yyyy";
    	String month="01";
    	String date="01";
		String normalizedDate="";
		
		try{
			if(dates != null){
				StringTokenizer part = new StringTokenizer(dates, " {}-?,.[]");  	
				while(part.hasMoreTokens()){
					String str=part.nextToken().trim();
					if(Character.isLetter(str.charAt(0)))
						 month=month2digit(str);
					else if(str.length()<=3)
						date=getDate(str);
					else{
						if(str.length()>=4 && str.length()<6)
							year=str.substring(0,4);
						 else if(str.length()==8)
							return normalizedDate=str.substring(0,4)+"-"+str.substring(4,6)+"-"+str.substring(6,8);
					}
 				}	
    
			} 	   
        }catch(Exception e){System.out.println(e);} 

        
		if(year.equals("yyyy")||year.compareTo(thisYear)>0)			
			normalizedDate="Misc";
 		else
			normalizedDate=year+"-"+month+"-" +date;
			
    	return normalizedDate;
    }

    public String month2digit(String month){
    	
	String mstr=month.toUpperCase();
     	
     	if(mstr.length()>3)
     		mstr=mstr.substring(0,3);

    	if(list.containsKey(mstr))
    		month=(String)list.get(mstr);
    	return month;
		
    }

    public String getDate(String dd){
    	String d="";

    	if(dd.length()>=3)
    		d=dd.substring(0,2);
    	else if(!Character.isDigit(dd.charAt(dd.length()-1))|| dd.length()==1)
    		d="0"+dd.substring(0,1);
    	else 
    		d=dd;
    	return d;
    }

            

}


