package parser;
import org.w3c.dom.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.*;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.*;
import java.io.*;

import oairequester.*;
/** Meta parser */
public abstract class MetaParser {
     Element recordElement = null;
    String archive = null;
    String sets = null;
    /** constructor */
    public MetaParser(){
	 
     }   
    /** 
     * validate
     *@param input 
     *@param archive
     *@param sets
     */

    public void validate (InputSource input, String archive, String sets)throws ParseException{
        if (archive != null)
	    this.archive = archive;
        if (sets != null)
	    this.sets = sets;
	
	try {
	    
	    DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.
	    							newInstance();
	    DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
            //docBuilder.setEntityResolver(null);
              
	    Document doc = docBuilder.parse (input);
	   
            //System.out.println("Doc is got !");

	    // normalize text representation
	    doc.getDocumentElement ().normalize ();
            recordElement = doc.getDocumentElement();

            
	} catch (SAXParseException err) {
           throw new ParseException("** Parsing error"
		+ ", line " + err.getLineNumber ()
		+ ", uri " + err.getSystemId ());
	    // print stack trace as below

	} catch (SAXException e) {
           throw new ParseException(e.getMessage());
	}catch (IOException ioe){
           throw new ParseException(ioe.getMessage());
        }catch (ParserConfigurationException pce){
           throw new ParseException(pce.getMessage());
        }
        
    }
    /** abstract parse oams */
    public abstract Result parseOAMS();
       
}





