package register;
import java.io.*;
import java.sql.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import db.*;
/**
 * registeration servlet
 */
public class Register extends HttpServlet{
    ConnectionPool cpool=null;
    /** do get
     *@param req HttpServletRequest
     *@param res HttpServletResponse
     */   
    public void doGet(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
    serve(req,res);
}
    /** do post
     *@param req HttpServletRequest
     *@param res HttpServletResponse
     */   

   public void doPost(HttpServletRequest req, HttpServletResponse res) throws ServletException, IOException{
       serve(req,res);
   }

    /** just do the service, called by both doGet and doPost
     *@param req HttpServletRequest
     *@param res HttpServletResponse
     */   
    public void serve(HttpServletRequest req, HttpServletResponse res) throws IOException{
	System.out.println("server");   
    Connection conn=null;
    String msg="";
    
    //get Parameters
       
    
    String id=req.getParameter("id");
    String baseurl=req.getParameter("baseurl");
    String homepage=req.getParameter("homepage");
    if ((id==null)||(baseurl==null)||(homepage==null)||(id.equals(""))||(baseurl.equals(""))||(homepage.equals(""))){
	msg="All fields must be filled";
    }
      else{
	  
	  try{
	       conn=(Connection) cpool.getConnection ();
	      PreparedStatement freestmt=null;
	      Statement stmt=conn.createStatement();
	      ;
	      ResultSet rset= stmt.executeQuery("select *  from dpinfo where id='"+id+"'");
	      if (rset.next()){
		  msg="Error! duplicate ID is used"; 
		  
	      }
	      else{	  
		  freestmt = conn.prepareStatement("insert into dplist(identifier,baseurl,active,harvestmethod,metaFormat,oaiversion) values (?,?,?,?,?,?)");
		  
		  freestmt.setString(1,id);
		  freestmt.setString(2,baseurl);
		  freestmt.setString(3,"Y");
		  freestmt.setString(4,"history_mass");
		  freestmt.setString(5,"oai_dc");
		  freestmt.setString(6,"2.0");
		  freestmt.executeUpdate();
		  freestmt.close();

		  freestmt=conn.prepareStatement("insert into dpinfo(id,baseurl,homepage) values (?,?,?)");
		  freestmt.setString(2,baseurl);
		  freestmt.setString(1,id);
		  freestmt.setString(3,homepage);
		  freestmt.executeUpdate();
		  freestmt.close();
		  
	      }
	      rset.close();
	      stmt.close();
	      msg="Your OAI Data Provider is successfully registerred, <p>ID:"+id+"<p>BaseURL:"+baseurl+"<p>Homepage:"+homepage;

	  }
	  catch (Exception e){
	      System.out.println(e);
	      msg="Registration failed";
	  }
	  finally
	  {
	      cpool.close(conn);
	  }
      }
  

      res.setContentType("text/html");
      PrintWriter out = res.getWriter();
      try{
	  out.write(msg);
	  out.flush();
	  out.close();
	  
      }catch(Exception e){
	  System.out.println(e);
      }                               
   }

    /**
     * servlet initialization
     * @param config ServletConfig
     */
 public void init (ServletConfig config) throws ServletException
    {


        ServletContext context=config.getServletContext();
        Object o=context.getAttribute(ConnectionServlet.KEY);
        
        if (o==null){
            throw new ServletException("ConnectionServlet not started");
        }

        cpool=(ConnectionPool)o;
 
    }

}
        
         
        
