package scheduler;


import java.util.*;
import oairequester.*;
import log.*;
/**
 *
 */
public class HarvestDmtAddAll extends HarvestByPartition{
    RecordList rlist;
    Enumeration rlistenum;
    String partitionname;
    boolean init=false;
    String m_format=null;

    int numorder = 0;

/**
 * Constructor
 * @param dp the data provider
 * @param oo
 * @param m_log
 */
    public HarvestDmtAddAll(DataProvider dp,Record2DB oo, Log m_log){
        super(dp,oo,m_log);
        rlist=new RecordList();
    }

/**
 * @return false.
 */
    public boolean forever(){
        return false;
    }


/**
 *
 */
    public void run() throws ParseException,java.io.IOException,ResponseException{
	
       Enumeration metafm = mfList.elements();

        if (init==false){
	    if (metafm.hasMoreElements()) {
		m_format = (String)metafm.nextElement();
		 System.out.println("Start harvesting "+m_format + " metadata ..."); 
	    /**
		m_logrecord = new LogRecord(Calendar.getInstance().getTime(),"HarvestDmtAddAll",dp.getId(),"Request", true);
		m_log.writeBeginLog(m_logrecord);
	    */
                 getList(m_format);
	      
                rlistenum=rlist.elements();		
		int totalsize = (rlist==null?0:rlist.size());
                init=true;
		
		/**
		m_logrecord.m_status = "OK";
		m_logrecord.m_detail = dp.getUrl() + "?verb=listIdentifiers";
		m_logrecord.m_totalnum = totalsize;
		m_log.writeEndLog(m_logrecord,dp.getId());*/

		System.out.println("Listing identifiers of " + m_format+ " is done");
	    }
	    else{
             rlist=null;
	     done=true;
	    }
        }
        else{
            if (rlistenum.hasMoreElements()){

                Record curr=   (Record)rlistenum.nextElement();
                String fullid=curr.m_id.trim();

		// Enumeration metafm = mfList.elements();
		// while (metafm.hasMoreElements()){
		     m_logrecord = new LogRecord(Calendar.getInstance().getTime(),"HarvestDmtAddAll",dp.getId(),"MAIN", false);
		m_log.writeBeginLog(m_logrecord);
   	   
		// String metaFormat = (String)metafm.nextElement();
                // System.out.println("Start harvesting "+m_format + " metadatas..");    
                 dp.getRecord.read(fullid, m_format);
            
                    Metadata md = dp.getRecord.preParse();
                    if(md.m_sets ==null)    
		       md.m_sets = curr.m_sets;
                    oo.add(md);
		 

		     numorder = numorder + 1;
		    m_logrecord.m_status = "OK";
		    m_logrecord.m_detail = "save each record to database";
		    m_logrecord.m_totalnum = numorder;
		    m_log.writeEndLog(m_logrecord,dp.getId());
		    

		    //  }

            }
            else{
                //rlist=null;
		//done=true;
		init=false;
	    }
        }//end if

    } //end run

    private void getList(String metaformat) throws ParseException,java.io.IOException,ResponseException{
         while (enum.hasMoreElements()) {
             String partitionname=(String)(enum.nextElement());
             if (partitionname.equals (FAKEFLAG))
                    partitionname=null;
             else
		   System.out.println("Harvesting set: "+ partitionname);
    
		 dp.listIdentifiers.read(partitionname,null,null, metaformat);
		 do{

		     rlist.addAll((RecordList)dp.listIdentifiers.parse());

		     try{
			 Thread.sleep(Config.SLEEP_BETWEEN_REQUEST);
		     }
		     catch(Exception e){
			 System.out.println(e);
		     }
		 } while(dp.listIdentifiers.getResumptionToken()!=null);
	      

          }
    }
}

