package search;
import java.io.*;
import java.util.zip.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class AttribSaver extends HttpServlet
{
//////////////////////////////////////////////////////////		
	public final static String SESSION_ARCHIVE_RANGE="AttribSaver.archive_range";
//////////////////////////////////////////////////////////	
	public void doGet (HttpServletRequest request,
                       HttpServletResponse response)
        throws ServletException, IOException
    {
    	HttpSession session = request.getSession(true);
    	String s1 = request.getParameter("attrib");
    	String s2 = request.getParameter("value");
    	//String display = request.getParameter("display");
    	
    	
    	if (s1!=null)
    	{
    		
    		session.setAttribute(s1,s2);
    		System.out.println ("Attrib = "+s1);
    		System.out.println ("Value = "+s2);
    		if (s1.equals (AttribSaver.SESSION_ARCHIVE_RANGE))
    		{
    			response.sendRedirect(request.getContextPath()+"/servlet/search?formname=last");
    			return ;
    		}
    	}
    	
    	String display = (String)session.getAttribute("display");    	
    	String page = AttribSaver.getPage (display);
    	response.sendRedirect(request.getContextPath()+page);
    	
    }
//////////////////////////////////////////////////////////	        
	public static String getPage (String display)
	{
		if (display==null)
			return "/results.jsp";
		display = display.toLowerCase ();
		display = display.trim ();
		if (display.equals("summary"))
			return "/summary.jsp";
		return "/results.jsp"	;
	}
//////////////////////////////////////////////////////////	        
	public void init (ServletConfig config) throws ServletException
    {    
	}
//////////////////////////////////////////////////////////	    
    public void destroy()
    {
	}
//////////////////////////////////////////////////////////	    
	public String getServletInfo() 
	{
        return "Attribute saver servlet";
    }
//////////////////////////////////////////////////////////	        
}