package search;
import java.sql.*;
import java.io.*;

import java.net.*;
import java.util.*;


public class FormData{
    Statement stmt=null;
    public Vector archives=null;
    Hashtable subject;
    public Hashtable set;
    Hashtable type;
    Hashtable language;


    public FormData(Connection c){
        archives=new Vector();
        subject=new Hashtable();
        set=new Hashtable();
        type=new Hashtable();
        language=new Hashtable();

      	try{
            stmt=c.createStatement();

        }catch (Exception e)
        {
		    e.printStackTrace();
        }

        readArchive();

        for (Enumeration enum=archives.elements ();enum.hasMoreElements() ;) {
            String archive=(String)(enum.nextElement());
            //subject.put(archive,readFields(archive,"subject"));
            set.put(archive,readFields(archive,"sets"));
            //type.put(archive,readFields(archive,"type"));
            //language.put(archive,readFields(archive,"language"));
        }

    }


    private void readArchive(){
        String query="select distinct archive from dc order by archive";
        ResultSet rset;
        try{
             rset=stmt.executeQuery(query);
	     System.out.println("Do query:"+query);
             while(rset.next()){
                String field =rset.getString(1);
                if (field!=null)
                    archives.add(field);
             }
        }
        catch (Exception e){
            System.out.println(e);
        }




    }

    private TreeSet readFields(String archive, String fieldname){
     String query="select distinct "+fieldname+" from dc where archive='"+archive+"'";
     String field;
     TreeSet treeset=new TreeSet();
     ResultSet rset;
        try{
             rset=stmt.executeQuery(query);
	     System.out.println("Do query"+query);
             while(rset.next()){
                field=rset.getString(1);
                if (field==null)
                    continue;
                StringTokenizer st = new StringTokenizer(field,"|");
                while (st.hasMoreTokens()) {
                    String sub=st.nextToken();
                    String subsub=(new StringTokenizer(sub,";")).nextToken();
                    treeset.add(subsub.trim());
                }

           }
        }catch(SQLException e){
            System.out.println(e);
        }
        return treeset;
     }

}



