/*
 * @(#)GroupItem.java        Feb 15,01
 *
 */


package search;
import java.io.*;
/**
 * Information about group item
 * @author xiaoming liu
 */

public class GroupItem implements Comparable,Serializable{
    public String groupid; // the group id, such as "arXiv"
    public String groupname; // group name, like "arXiv-eprints" service
    public int size=0;  //result size in this group

    public String getEncodedId(){
        return java.net.URLEncoder.encode(groupid);
    }

    public GroupItem(String id, int size) {
        this.groupid=id;
        this.size=size;
    }

    /**
     * order by groupid
     */
    public int compareTo(Object o){
        GroupItem an=(GroupItem)o;
        return this.groupid.compareToIgnoreCase(an.groupid);
    }
}
