/*
 * @(#)SimpleParam.java        02/15/01
 *
 *
 */
package search;
import javax.servlet.*;
import javax.servlet.http.*;

/**
  * SimpleParam implements getting parameter from search request, it should be
  * inherited by all simple search interface
  *
  * @version 1.0 02/15/01
  * @author Xiaoming Liu
  */

public abstract class SimpleParam extends SearchParam
{

    //input from fulltext field
    String fulltext;

    //input from sort field
    String sort;

    //input from group field
    String group;
////////////////////////////////////////////////////////////////////
     /**
      * Constructor
      * @param request Servlet request
      */

     public SimpleParam(HttpServletRequest request)
     {
          	fulltext = padSpecialChar(request.getParameter("fulltext"));
          	mark_creator = fulltext;
          	mark_title = fulltext;
          	mark_description = fulltext;
            sort=request.getParameter("sort");
            group=request.getParameter("group");
		
     }
////////////////////////////////////////////////////////////////////
      public String getTableName()
      {
            return "free";
      }
////////////////////////////////////////////////////////////////////
}
