import java.util.*;
//inneholder en arrayList med alle subjectnavnene, og et hasSet og en arrayliste med alle subjectene. 
public class SubjectList {
	DbId idtabell;
	ArrayList subjects;
	
	
	public SubjectList(){
		idtabell = new DbId();
		subjects = new ArrayList();
		initiateSubjectName();
		setSubjectList();
	}
	public ArrayList initiateSubjectName(){
		ArrayList subjectList = new ArrayList();
		ArrayList idTabell = idtabell.getId();
		if(idTabell.isEmpty()){
			idtabell.setIdTabell();
		}
		for(int i=0; i<idTabell.size(); i++){
			String su = idtabell.getKolInn(i, "subject");
			StringTokenizer s = new StringTokenizer(su, "|");
			while(s.hasMoreTokens()){
				String subject = s.nextToken().trim();
				subject = fjernTegnSubject(subject).trim();
				if(!subjectList.contains(subject)){
					subjectList.add(subject);
				}
			}
		}return subjectList;
	}
	public int getAntDifferentSubject(){
		int numberDifSub = initiateSubjectName().size();
		return numberDifSub;
	}
	public String fjernTegnSubject(String subject){
		for(int i = 0; i<subject.length(); i++){
			char a = subject.charAt(i);
			if(a == ',' || a == '.' || a== '\"'|| a== '(' || a==')' || a == '!' || a == '?' || a ==':' || a== ';' || a=='[' ||a==']'){
					char b = ' ';
					subject = subject.replace(a, b);
			}
		}return subject;
	}
	public void setSubjectList(){
		ArrayList subjectnames = initiateSubjectName();
		for(int i=0; i<subjectnames.size(); i++){
			String name = (String)subjectnames.get(i);
			Subject subject = new Subject(name);
			subjects.add(subject);
		}
	}
	public boolean isInList(String subjectName){
		boolean found = false;
		if(subjects.size() != 0){
			for(int i=0; i<subjects.size(); i++){
				String en = subjects.get(i).toString();
				String to = subjectName;
				if(en.equals(to)){
					found = true;
				}
			}
		}
		return found;
	}
	public ArrayList getSubjectList(){
		return subjects;
	}
	public int getSubjectIndex(String subjectName){
		for(int i=0; i<subjects.size(); i++){
			if(subjects.get(i).toString().equals(subjectName)){
				return i;
			}
		}
		return -1;
	}
	public static void main(String[] args){
		SubjectList s = new SubjectList();
		System.out.println(s.getAntDifferentSubject());
		System.out.println(s.initiateSubjectName().toString());
		s.setSubjectList();
	}

}
