package dienst;

import db.*;
import java.sql.*;
import java.io.*;
import java.util.*;

/**
 * Scheduler configuration
 * Data is loaded from Database
 *
 *@ author padsh_m@cs.odu.edu
Created on 05/10/2002
 */

public class Config
{
ConnectionPool cpool;
Connection con=null;
//sleeptime between request, time unit is second
    public static int SLEEP_BETWEEN_REQUEST=60;

//sleeptime between next harvest, time unit is minutes
    public static int SLEEP_BETWEEN_HARVEST=1;

//In the fresh harvest, the day prior today
    public static int HARVEST_RANGE=3;

//the user agent for http request
    public static String AGENT="null";

    public static String DP_LIST_SOURCE="database";

    public static String HOSTNAME="null";
/*the cache dir
    CACHE_DIR is optional in scheduler.cfg file, if no cache_dir is defined,
     we suppose there is no cache requirement.
     */
     public static String CACHE_DIR=null;


    /**
     * Default constructor
     */

    public Config(ConnectionPool m_connectionPool)
	{
	try{
                        cpool=m_connectionPool;
         		con=cpool.getConnection();
			Statement stmt=null;
			stmt = con.createStatement();
	        ResultSet schd = stmt.executeQuery("select REQUEST_SLEEP,HARVEST_SLEEP,HARVEST_RANGE,USER_AGENT,HOSTNAME from scheduler");
		    schd.next();

			SLEEP_BETWEEN_REQUEST = schd.getInt(1);
		    SLEEP_BETWEEN_HARVEST = schd.getInt(2);
		    HARVEST_RANGE = schd.getInt(3);
		    AGENT = schd.getString(4);
			DP_LIST_SOURCE = "database";
		    HOSTNAME = schd.getString(5);
//		    CACHE_DIR=prop.getProperty("cache_dir");

        }
        catch(Exception e){
            System.out.println(e);
        }
    }


}
