package dienst;

import java.text.*;
import java.util.*;
public class DataProvider{
/**
 * archival identifer
 */
    public String m_id;
/**
 * archival URL
 */

    String m_url;
    String m_displayurl;
    String m_set;
    Date m_lasttime;
    String m_metaFormat;

    public PartitionList m_partitionList;
    public MetaFmtList m_metaFmtList;
    public ListRecords listRecords;
    public GetRecord getRecord;
    public ListSets listsets;
    public ListIdentifiers listIdentifiers;
    public ListMetadataFormat listMetadataFormat;
    public Identify identify;
    public ListMetaFormats listMetaFormats;

    public DataProvider(String id, String url, String set, String lastharvesttime, String metaFormat){
    	m_id=id;
	m_url=url;
	m_set=set;
        m_metaFormat = metaFormat;

	System.out.println("lastharvesttime="+lastharvesttime);
	if (lastharvesttime != null) {
	     SimpleDateFormat formatter = new SimpleDateFormat("yyyy.MM.dd HH:mm:ss");
	    try{
		m_lasttime = formatter.parse(lastharvesttime);
	    }
	    catch(Exception e){
		System.out.println("date format translation error");
	    }
	} else 
	    m_lasttime = null;
	System.out.println("m_lasttime in dataprovider.java"+m_lasttime);
        listRecords=new ListRecords(this);
        getRecord=new GetRecord(this);
        listsets=new ListSets(this);
        listMetadataFormat=new ListMetadataFormat(this);
        listIdentifiers=new ListIdentifiers(this);
        identify=new Identify(this);
        listMetaFormats = new ListMetaFormats(this);
    }

    public String getSet() {
	return m_set;
    }

    public String getId() {
	return m_id;
    }

    public String getUrl() {
	return m_url;
    }

    public Date getLasttime() {
	return m_lasttime;
    }

    public String getMetaFormat() {
	return m_metaFormat;
    }

    
}




