package dienst;
import java.util.*;
import org.w3c.dom.*;
import org.xml.sax.*;

public class Disseminate extends Response{
    public Disseminate(DataProvider dp){
        super(dp);
    }

    public void read(String fullID,String meta_format,String content_type) throws java.io.IOException{
        read(dp.m_url+"/Repository/1.0/Disseminate/"+fullID+"/%23"+meta_format+"/"+content_type);
    }

    public Result parse() throws ParseException,java.io.IOException, ResponseException{
        try{
            Element e= super.validate();
            NodeList n=e.getChildNodes();
            Node recordElement=null;

            //find oams record
            for (int i=0;i<n.getLength();i++){
                if (n.item(i).getNodeType()==Node.ELEMENT_NODE){
                    recordElement=n.item(i);
                    break;
                }
            }

            if (recordElement == null)
                throw new NoRecordException("");
            return MetaParser.parseOAMS((Element)recordElement);
        }
        catch (NoRecordException exception){
            throw new NoRecordException(requesturl+"'s response does not have record");
        }
    }
}






