package dienst;
import java.util.*;

public class PartitionList extends Vector implements Result{
    Hashtable map=new Hashtable();

    public void add(String name,String description){
	map.put(name,description);
        StringTokenizer st = new StringTokenizer(name,":");
        
	 if (st.countTokens()==1){
            Partition p=new Partition(name,description);
            add(p);
        }
        else{
           String parent=st.nextToken();        
           String child=name.substring (name.indexOf (":")+1);
           boolean isAdded = false;
           for (Enumeration e = elements() ; e.hasMoreElements() ;) {
                 Partition p=(Partition)(e.nextElement());
                 if (p.m_name.equals (parent)){
                    p.getSubList().add(child,description);
                    isAdded = true;
                    break;
                 }
            }
	   if (!isAdded){
               Partition p=new Partition(parent,description);
               p.getSubList().add(child,description);
              add(p);            
	  }
	}

    }

    /*
     * get a string vector of paritition, the content of vector is decided by level
     */
    public Vector getHierarchyPartition(int level){
        return getHierarchyPartition(null,level);
    }

    Vector getHierarchyPartition(String prefix,int level){
         Vector list=new Vector();
         for (Enumeration e = elements() ; e.hasMoreElements() ;) {
             Vector sub=((Partition)(e.nextElement())).getHierarchyPartition(prefix,level);
             list.addAll(sub);
         }
         return list;
    }

    public Vector getHierachypartitionWithParent(int level){
        return getHierachyPartitionWithParent(null,level);
    }

    Vector getHierachyPartitionWithParent(String prefix,int level){
         Vector list=new Vector();
         for (Enumeration e = elements() ; e.hasMoreElements() ;) {
             Vector sub=((Partition)(e.nextElement())).getHierarchyPartitionWithParent(prefix,level);
             list.addAll(sub);
         }
         return list;
    }

        public Vector getHierarchyPartitionName(int level){
        Vector list=new Vector();
         for (Enumeration e = elements() ; e.hasMoreElements() ;) {
             Vector sub=((Partition)(e.nextElement())).getHierarchyPartitionNameWithParent(level);
             list.addAll(sub);
         }
         return list;
    }

    public String getSpecByName(String name){
	
	return (String)map.get(name);
    }


}
