package dienst;
/*
 * @(#)URIEncoder.java
 * Created: Wednesday April 26th, 2000
 * Copyright 2000 ODU CS
 *
 * All rights reserved
 */

/**
 * The class contains a utility method which turns a string into URI format
 */

public class URIEncoder{

/**
 * Turns a string into URI format
 */       
    public static String encode(String s)
    {
	if (s==null)
	    return "";
	StringBuffer sb=new StringBuffer();
	int beginpos=0,endpos=0;
	while(endpos<s.length())
	{
        if (s.charAt(endpos)=='\u0020'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%20");
            beginpos= ++endpos;
        }

        else if(s.charAt(endpos)=='\n'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%0D%0A");
            endpos++;
            beginpos=endpos;
        }
        else if(s.charAt(endpos)=='\u002F'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%2F"); //processing /
            beginpos= ++endpos;
        }
        else if(s.charAt(endpos)=='\u003F'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%3F"); //processing ?
            beginpos= ++endpos;
        }
	else if(s.charAt(endpos)=='\u0023'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%23"); //processing #
            beginpos= ++endpos;
        }
	else if(s.charAt(endpos)=='\u003D'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%3D"); //processing =
            beginpos= ++endpos;
        }
	else if(s.charAt(endpos)=='\u0026'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%26"); //processing &
            beginpos= ++endpos;
        }
	else if(s.charAt(endpos)=='\u003A'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%3A"); //processing :
            beginpos= ++endpos;
        }
	else if(s.charAt(endpos)=='\u003B'){
            sb.append(s.substring(beginpos,endpos));
            sb.append("%3B"); //processing ;
            beginpos= ++endpos;
        }
        else
            endpos++;
    }
    sb.append(s.substring(beginpos,endpos));
    return new String(sb);
    }
}
