package interactive.createSubject;
import java.sql.*;
import java.io.*;

import java.net.*;
import java.util.*;

public class DB{
    Statement stmt=null;
    Hashtable archives=null;

    public DB(Connection c){
        archives=new Hashtable();
        try{
            stmt=c.createStatement();
       }catch (Exception e)
        {
                    e.printStackTrace();
        }

        readArchive();

        for (Enumeration enum=archives.keys ();enum.hasMoreElements() ;) {
            String archivename=(String)(enum.nextElement());

       
        Hashtable value=(Hashtable)(archives.get(archivename));
        value.put("subject",readFields(archivename,"subject"));
/*        }
         stmt.close();
         c.close();
        }catch (Exception e)
        {
                    e.printStackTrace();
        }*/
       }
    }

    private void readArchive(){
        String query="select distinct archive from dc";
        ResultSet rset;
        try{
             rset=stmt.executeQuery(query);
             while(rset.next()){
                String field =rset.getString(1);
                if (field!=null)
                    archives.put(field, new Hashtable());
             }
        }catch (Exception e){
            System.out.println(e);
        }
    }

    private TreeSet readFields(String archive, String fieldname){
     String query="select distinct "+fieldname+" from dc where archive='"+archive+"'";
     String field;
     TreeSet treeset=new TreeSet();
     ResultSet rset;
        try{
             rset=stmt.executeQuery(query);

             while(rset.next()){
                field=rset.getString(1);

                if (field==null)
                    continue;

            

            StringTokenizer st = new StringTokenizer(field,"|");
                while (st.hasMoreTokens()) {
                String sub=st.nextToken();
               

                    StringTokenizer  st2 = new StringTokenizer(sub,";");
                    while ( st2.hasMoreTokens())   {
                        String subsub = st2.nextToken();
                      

                      StringTokenizer  st3 = new StringTokenizer(subsub,",");
                      while ( st3.hasMoreTokens())   {
                        String subsubsub = st3.nextToken().trim();
                       

                        if ( subsubsub.equalsIgnoreCase("null") ||
                              subsubsub.equals("") )
                            continue;

                        treeset.add(subsubsub);
                      }

                    }
                }

  

           }
        }catch(SQLException e){
            System.out.println(e);
        }
        return treeset;
     }

}





