package ns;

/**
 * Detail information about data provider
 * this information is used by search engine and service provider interface
 */
public class DPInfo implements Comparable  {
    public String id;
    public String baseURL;
    public String homepage;
    public String name;
    public String version;
    public String adminemail;
    public String delimiter;
    public String sampleIdentifier;
    public String schema;
    public String lastharvesttime;
    public String harvestmethod;

    public String toString(){
        return "id="+id+";baseURL="+baseURL+":hompdage="+homepage+":name="+name+"lastharvesttime:"+lastharvesttime+" harvestmethod"+harvestmethod;
    }

   public int compareTo(Object o){
	DPInfo dp=(DPInfo)o;
	return id.compareToIgnoreCase(dp.id);
    }
}
