package scheduler;


import java.util.*;
import dienst.*;
import log.*;

public class HarvestDmtAddAll extends HarvestByPartition{
    RecordList rlist;
    Enumeration rlistenum;
    String partitionname;
    boolean init=false;
    int numorder = 0;

    public HarvestDmtAddAll(DataProvider dp,Record2DB oo, Log m_log){
        super(dp,oo,m_log);
        rlist=new RecordList();
    }

    public boolean forever(){
        return false;
    }


    public void run() throws ParseException,java.io.IOException,ResponseException{
        if (init==false){
		m_logrecord = new LogRecord(Calendar.getInstance().getTime(),"HarvestDmtAddAll",dp.getId(),"Request", true);
		m_log.writeBeginLog(m_logrecord);		 
                getList();
                rlistenum=rlist.elements();		
		int totalsize = (rlist==null?0:rlist.size());
                init=true;
		m_logrecord.m_status = "OK";
		m_logrecord.m_detail = dp.getUrl() + "?verb=listIdentifiers";
		m_logrecord.m_totalnum = totalsize;
		m_log.writeEndLog(m_logrecord,dp.getId());
        }
        else{
            if (rlistenum.hasMoreElements()){

                Record curr=   (Record)rlistenum.nextElement();
                String fullid=curr.m_id.trim();

               Enumeration metafm = mfList.elements();
               while (metafm.hasMoreElements()){
		m_logrecord = new LogRecord(Calendar.getInstance().getTime(),"HarvestDmtAddAll",dp.getId(),"MAIN", false);
		m_log.writeBeginLog(m_logrecord);
   	   
		 String metaFormat = (String)metafm.nextElement();
                 System.out.println("Start harvesting "+metaFormat + " metadatas..");    
                 dp.getRecord.read(fullid, metaFormat);
            
		 // try{
                    Metadata md = dp.getRecord.preParse();
                    md.m_sets = curr.m_sets;
                    oo.add(md);
		    /* Record r=(Record)dp.getRecord.parse();
                    r.m_sets=curr.m_sets;
                    oo.add (dp.m_id,r);*/

		    numorder = numorder + 1;
		    m_logrecord.m_status = "OK";
		    m_logrecord.m_detail = "save each record to database";
		    m_logrecord.m_totalnum = numorder;
		    m_log.writeEndLog(m_logrecord,dp.getId());
		    //  }
		    /* catch  (ParseException e){
                    ParseException p=new ParseException(fullid+": "+e);
                    throw p;
		    }*/
	       }

            }
            else{
                rlist=null;
		done=true;
	    }
        }//end if
    } //end run

    private void getList() throws ParseException,java.io.IOException,ResponseException{
         while (enum.hasMoreElements()) {
             String partitionname=(String)(enum.nextElement());
             if (partitionname.equals (FAKEFLAG))
                    partitionname=null;
             else
		   System.out.println("Harvesting set: "+ partitionname);
	     /**  Date d=new Date();
	     if (dp.getSet() == null || dp.getSet().length() ==0 || ((partitionname != null) && (partitionname.equals(dp.getSet())))) {
             */
		 dp.listIdentifiers.read(partitionname,null,null);
		 do{

		     rlist.addAll((RecordList)dp.listIdentifiers.parse());

		     try{
			 Thread.sleep(Config.SLEEP_BETWEEN_REQUEST);
		     }
		     catch(Exception e){
			 System.out.println(e);
		     }
		 } while(dp.listIdentifiers.getResumptionToken()!=null);
	      

          }
    }
}
