package scheduler;
/**
 * Give a harvested "list-contents" file name, this task can add records to database 
 * However, this task has a limitation that partition is missed in record generally, 
 * To make data complete in database, This task can be companied by HarvestUpdatePartition 
 * task. 
 */
import java.util.*;
import dienst.*;
import java.io.*;
public abstract class HarvestFromFile implements Task{
    DataProvider dp;
    Record2DB oo;
    File file;
    boolean done=false; 
    public boolean forever(){ 
	return false;
    }

    public  HarvestFromFile(DataProvider dp,Record2DB oo,File file){ 
	this.dp=dp;
        this.oo=oo;
        this.file=file; 
    }

    public void prepare() throws dienst.ParseException,java.io.IOException{         done=false;
    }// read partition 

    public void run() throws ParseException,java.io.IOException{
        if (file.isFile()){ 
	    dp.listRecords.read(file); 
	    oo.add(dp.m_id,(RecordList)dp.listRecords.parse());  
	}
        else{  
	    File filelist[]=file.listFiles();   
	    for (int i=0;i<filelist.length;i++){ 
		dp.listRecords.read(filelist[i]); 
		oo.add(dp.m_id,(RecordList)dp.listRecords.parse());
            }
        }
        done=true;
    }
    
    public boolean isDone(){    
	return done; 
    }
}
