package scheduler;
import java.util.*;
import dienst.*;
import log.*;
public class HarvestPartition implements Task {
    DataProvider dp;
    Vector pList; 
    Vector nameList;
    boolean done=false;    
    public  HarvestPartition(DataProvider dp){  
	this.dp=dp;    
    } 
    public boolean forever(){  
	return false;
    }
    
    public void prepare() throws dienst.ParseException,java.io.IOException{ 
        dp.listsets.read();
	PartitionList pl=(PartitionList)dp.listsets.parse();
	pList=pl.getHierachypartitionWithParent(1); 
        nameList=pl.getHierarchyPartitionName(1);    
	done=false;
    }

    public void run(){
        for(Enumeration e=pList.elements();e.hasMoreElements();) 
	    {
		System.out.println("s1=s1+\"~"+(String)(e.nextElement())+"\";");      
	    } 
	System.out.println("Begin name section");
	for(Enumeration enum=nameList.elements();enum.hasMoreElements();)        
	    {
		System.out.println("s1=s1+\"~"+(String)(enum.nextElement())+"\";");     
	    }
        done=true; 
    }    

    public boolean isDone(){
        return done;  
    }

    
    public LogRecord getLog(){
	return null;
    }
} 
