package scheduler;
import java.io.*;
import java.sql.*;

import db.*;

/**
 * Save data to Oracle database
 * @author xiaoming liu
 */

public class Record2Oracle extends Record2DB{

    public Record2Oracle(ConnectionPool pool) {
        super(pool);
    }

    /**
      * User could get rapid result by doing reindex*
      */

     public void reindex(){
	connection=m_connectionPool.getConnection();
        Statement s=null;
        try{
            s=connection.createStatement();
            s.execute("alter index arc_dc_description rebuild online parameters('sync')");
            s.execute("alter index arc_dc_title rebuild online parameters('sync')");
            s.execute("alter index arc_dc_creator rebuild online parameters('sync')");
            s.execute("alter index arc_dc_sets rebuild online parameters('sync')");
            s.execute("alter index arc_dc_subject rebuild online parameters('sync')");
            s.execute("alter index arc_dc_publisher rebuild online parameters('sync')");
            s.execute("alter index arc_dc_discovery rebuild online parameters('sync')");
            s.execute("alter index arc_dc_type rebuild online parameters('sync')");
            s.execute("alter index arc_dc_format rebuild online parameters('sync')");
            s.execute("alter index arc_dc_source rebuild online parameters('sync')");
            s.execute("alter index arc_dc_language rebuild online parameters('sync')");
            s.execute("alter index arc_dc_relation rebuild online parameters('sync')");
            s.execute("alter index arc_dc_coverage rebuild online parameters('sync')");
            s.execute("alter index arc_dc_rights  rebuild online parameters('sync')");
            s.execute("alter index arc_dc_datestamp rebuild online parameters('sync')");
            s.execute("alter index arc_free_alltext rebuild online parameters('sync')");
 s.execute("alter index arc_dcnew_subject rebuild online parameters('sync')");

        }
        catch (SQLException e){
            System.out.println(e);
        }
        finally{
            try{
                s.close();
		m_connectionPool.close(connection);
            }
            catch(Exception e){
                System.out.println(e);
            }
        }
    }


} 
