package arc20.dp;

import java.io.*;
import java.util.zip.*;
import java.util.*;
import java.lang.*;
import java.awt.event.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

import db.*;
import arc20.*;
import dataprovider20.*;


public class DPOAI extends arc20.OAI
{
    ConnectionPool cpool;

    public void init (ServletConfig servletconfig) throws ServletException
    {

        ServletContext context=servletconfig.getServletContext();
        Object o=context.getAttribute(ConnectionServlet.KEY);
        if (o==null){
            throw new ServletException("ConnectionServlet not started");
        }

        cpool=(ConnectionPool)o;

     
        config=new DPIdentify(cpool);
        rf=new TRIRecordFactory(cpool);
       
    }

    //////////////////////////////////////////////////////
    public String getServletInfo() {
        return "The Data provider OAI Servlet";
    }

     //////////////////////////////////////////////////////
    public void destroy()
    {
        if (cpool!=null)
            cpool.destroy();
        super.destroy();
    }
}
