package log;

import java.io.*;
/**
 * File Log
 */
public class FileLog {
    /**
     * write error into error.log
     * @param e the error string
     */
    public static void writeError(String e){
        try{
            FileWriter error=new FileWriter("error.log",true);
            System.out.println(e);
            error.write(e);
            error.close();
        }
        catch (Exception ex){
            System.out.println(ex);
        }
    }


    /**
     * write status into status.log
     * @param s the status string
     */
    public static void writeStatus(String s){
        try{
            FileWriter status=new FileWriter("status.log");
            System.out.println(s);
            status.write(s);
            status.close();
        }
        catch(Exception e){
            System.out.println(e);
        }
    }


}
