package oairequester;
import java.io.*;
import java.net.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import org.xml.sax.*;
import org.xml.sax.SAXParseException;
import java.util.*;
/** Jan 9, 2002 by Yang Zhao
  * A Generic Filter 
*/
public abstract class Filter {

  protected String xmldoc;//used for checking
  
  Filter (InputSource inputsource) {
    xmldoc = "";
    try{
          BufferedReader breader = new BufferedReader (
                         new InputStreamReader(inputsource.getByteStream()) );
          String line;
	  String tmp="";
          while( (line=breader.readLine()) != null ){
            tmp += line + "\n";
	  }

	  StringTokenizer st=new StringTokenizer(tmp,">");
	  while (st.hasMoreTokens()){
	      xmldoc+=st.nextToken()+">\n";

	      // System.out.println(" Break a line ! ");
	  }
	  xmldoc=xmldoc.substring(0,xmldoc.length()-2);
	  

	
       }catch (IOException ioe){
             System.out.println(ioe);
       }    
   }

  public InputSource getInputSource () throws IOException{
      InputSource input = new InputSource (new StringReader(xmldoc));
       return input;
  }
  
  public abstract void process() throws IOException;
  
  }
