package oairequester;
import org.w3c.dom.*;
import org.xml.sax.*;
import java.util.*;

import ns.*;

public class Identify extends Response{

    public Identify(DataProvider dp){
        super(dp);
    }

    public void read() throws java.io.IOException{
        read(dp.m_url+"?verb=Identify");
    }


    public Result parse() throws java.io.IOException,oairequester.ParseException{
        IdentifyInfo info=new IdentifyInfo();
        Element e= validate();

        NodeList n=e.getChildNodes();
    
        for (int i=0;i < n.getLength();i++){
            if (n.item(i).getNodeType()==Node.ELEMENT_NODE){
                Element prop=(Element)(n.item(i));
                if (prop.getTagName().equals ("repositoryName"))
                    info.name= MetaParser.fetchChild(prop);
                if (prop.getTagName().equals ("baseURL"))
                    info.baseURL=MetaParser.fetchChild(prop);
                 if (prop.getTagName().equals ("protocolVersion"))
                    info.version=MetaParser.fetchChild(prop);
                if (prop.getTagName().equals ("adminEmail"))
                    info.adminemail=MetaParser.fetchChild(prop);
                 if (prop.getTagName().equals ("granularity"))
                    info.granularity=MetaParser.fetchChild(prop);

                if (prop.getTagName().equals("description")){
                    NodeList oainode=prop.getChildNodes();
                    for (int j=0;j<oainode.getLength();j++){
                        if (oainode.item(j).getNodeType()==Node.ELEMENT_NODE){
                            Element oaiidentifier=(Element)(oainode.item(j));
                            if (oaiidentifier.getTagName().equals("oai-identifier")){
                                NodeList children=oaiidentifier.getChildNodes();
                                for (int m=0;m<children.getLength ();m++){
                                    if (children.item(m).getNodeType()==Node.ELEMENT_NODE){
                                        Element shit=(Element)(children.item(m));
                                        if (shit.getTagName ().equals("scheme"))
                                            info.schema=MetaParser.fetchChild(shit);
                                        if (shit.getTagName().equals("repositoryIdentifier"))
                                            info.id=MetaParser.fetchChild (shit);
                                        if (shit.getTagName().equals("delimiter"))
                                            info.delimiter = MetaParser.fetchChild(shit);
                                        if (shit.getTagName().equals("sampleIdentifier"))
                                            info.sampleIdentifier =MetaParser.fetchChild(shit);
                                    }//end if
                                }//end for
                            }//end if

                        }//end if
                    }      //end for
                }//end if
            }//end if
        } //end for
        if (info.id==null)
            info.id=dp.m_id; 
        return info;
    }

}
