package oairequester;
import org.w3c.dom.*;
import org.xml.sax.*;
import java.util.*;
public class ListMetaFormats extends Response{

    public ListMetaFormats(DataProvider dp){
        super(dp);
    }

      public void read(String identifier) throws java.io.IOException{
          String s = "?verb=ListMetadataFormats";
	  if (identifier != null)
	      s += "&identifier="+identifier;   
          super.read(dp.m_url+ s);
    }


    public Result parse() throws java.io.IOException,oairequester.ParseException{
        MetaFormatsList fmtList=new MetaFormatsList();
        Element e= validate();
        NodeList n=e.getChildNodes();
        for (int i=0;i<n.getLength();i++){
           if (n.item(i).getNodeType()==Node.ELEMENT_NODE){
               Element el = (Element)n.item(i);
	       if (el.getTagName().equals("metadataFormat")){
		   Element mf = (Element)n.item(i);
                   NodeList nl = mf.getElementsByTagName("metadataPrefix");
                   String format = nl.item(0).getFirstChild().getNodeValue().trim();
                   fmtList.add(format);
               }
           }
	}
        return fmtList;
    }

}
