package parser;

import oairequester.*;
import db.*;
public class Parse {
    ConnectionPool m_connectionPool = null;
    DB2DB db2db = null;
 
    public Parse(String type){
        m_connectionPool=new ConnectionPool(); 
        try{ 
            m_connectionPool.initialize();
        }
        catch(Exception ex){
            ex.printStackTrace();
        }

	db2db = new DB2DB(m_connectionPool, type);	
    }
    
    public void exec(String format){
       
         db2db.parse(format);
           
    }     

   public static void main(String args[]){
       /**
       if (args.length == 1){
	   //System.out.println("Usage: Java parse.Parse [Meta Format]");
           //System.exit(1);
       
         Parse parse = new Parse("-n");
         parse.exec(args[0]);
       }
       */

       if (args.length == 2){
	   if (! ( args[0].equals("-n") || args[0].equals("-a") ) ){
               System.out.println("Usage: Java parse.Parse [ -n || -a ] [Meta Format] ");
               System.out.println(" -n : only parse the new metadata" + "/n" + "-a : parse all metadata");
               System.exit(1);}

         Parse parse = new Parse(args[0]);
         parse.exec(args[1]);
       }
       
       else{
	   System.out.println("Usage: Java parse.Parse [ -n || -a ] [Meta Format]");
           System.out.println(" -n : only parse the new metadata" + "\n" + "-a : parse all metadata");
           System.exit(1);
       }
       
      System.exit(0);
  }

}
