package scheduler;
import java.io.*;
import java.util.*;
import oairequester.*;

/** harvest to file */
public class Harvest2File extends HarvestByPartition{   
    File dir; 
    /**
     * @param dp Data provider
     * @param oo 
     * @param dir
     */
    public Harvest2File(DataProvider dp,Record2DB oo,File dir)
    {
	super(dp,oo,null);
	this.dir=dir;    
    }
    // read partition
    
    /**
     * read partition
     */
    public void run() throws ParseException,java.io.IOException
    {            	
	if (enum.hasMoreElements()) {                
	    String partitionname=(String)(enum.nextElement());
	    dp.listRecords.read(partitionname,null,null,"dc");           	
	    File file=new File(dir,partitionname+".xml");         
	    file.createNewFile();                               
	    dp.listRecords.write(file);
	}
	else
	    done=true;    
    } 

    /**
     * @return false
     */
    public boolean forever()
    {
	return false;   
    }
}
