package scheduler;
import java.util.*;
import oairequester.*;
import log.*;
public class HarvestPartition implements Task {
    DataProvider dp;
    Vector pList; 
    Vector nameList;
    boolean done=false;    
    /**
     * constructor
     *@param dp the data provider
     */
    public  HarvestPartition(DataProvider dp){  
	this.dp=dp;    
    } 
    /**
     *@return falase
     */
    public boolean forever(){  
	return false;
    }
    /**
     * prepare
     */
    public void prepare() throws oairequester.ParseException,java.io.IOException{ 
        dp.listsets.read();
	PartitionList pl=(PartitionList)dp.listsets.parse();
	pList=pl.getHierachypartitionWithParent(1); 
        nameList=pl.getHierarchyPartitionName(1);    
	done=false;
    }
    /**
     *
     */
    public void run(){
        for(Enumeration e=pList.elements();e.hasMoreElements();) 
	    {
		System.out.println("s1=s1+\"~"+(String)(e.nextElement())+"\";");      
	    } 
	System.out.println("Begin name section");
	for(Enumeration enum=nameList.elements();enum.hasMoreElements();)        
	    {
		System.out.println("s1=s1+\"~"+(String)(enum.nextElement())+"\";");     
	    }
        done=true; 
    }    
    /** @return true if done */
    public boolean isDone(){
        return done;  
    }

    /** @return null all the time!*/
    public LogRecord getLog(){
	return null;
    }
} 


