package scheduler;
import oairequester.*;
import log.*;
/**
  * Task to be called by scheduler,
  */
public interface  Task {
    /** prepare */
    public void prepare()  throws oairequester.ParseException,java.io.IOException;
    /** run */
    public void run() throws ParseException,java.io.IOException,ResponseException;
    /** is it done */
    public boolean isDone();
    /** is it forever*/
    public boolean forever();
    /** get log */
    public LogRecord getLog();
}
