package search;
 // class CSearchParams

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;

public abstract class AdvancedParam extends SearchParam
{
    boolean and_or=true;   // and = TRUE , or = FALSE
    String creator;
    String title;
    String description;
    String archive;
    String sets;
    String subject;
    String publisher;
    String contributor;
    String type;
    String format;
    String source;
    String language;
    String relation;
    String coverage;
    String rights;

    String datestamp;
    String discovery;

    String query;
    String sort;
    String rankitem;

     //input from group field
    String group;
///////////////////////////////////////////////////////
    public AdvancedParam(HttpServletRequest request)
    {
        	creator = request.getParameter("creator");
        	mark_creator = creator;
			title = request.getParameter("title");			
			mark_title = title;
			description = request.getParameter("description");
			mark_description = description;
			archive = request.getParameter("archive");
			sets = request.getParameter("sets");
			subject = request.getParameter("subject");
            publisher = request.getParameter("publisher");
            contributor = request.getParameter("contributor");
            type = request.getParameter("type");
            format = request.getParameter("format");
            source = request.getParameter("source");
            language = request.getParameter("language");
            relation = request.getParameter("relation");
            coverage = request.getParameter("coverage");
            rights = request.getParameter("rights");
			datestamp = request.getParameter("datestamp");
            discovery = request.getParameter("discovery");
    		and_or = request.getParameter("boolean").equals ("and");
            sort=request.getParameter("sort");
            group=request.getParameter("group");
			if (group.indexOf ("discovery")>-1)
			{
				group = "substr (normdiscovery,0,4)";
			}

    }
///////////////////////////////////////////////////////
    protected void formalize()
    {
        creator=specialforcreator(creator);
        title=padSpecialChar(title);
        description=padSpecialChar(description);
        sets=padSpecialChar(sets);
        subject=padSpecialChar(subject);

        publisher=padSpecialChar(publisher);
        contributor=padSpecialChar(contributor);
        type=padSpecialChar(type);
        format=padSpecialChar(format);
        source=padSpecialChar(source);
        language=padSpecialChar(language);
        relation=padSpecialChar(relation);
        coverage=padSpecialChar(coverage);
     }
///////////////////////////////////////////////////////

    //this is special processing for creator for jim moore's advice
    // In author field, sequence is not important
    // it uses proximity operator and wildcard in oracle context server
    private String specialforcreator(String in)
    {

        if (in==null)

            return null;


        if (in.trim().equals(""))

            return "";

        String temp=in.replace('.',' ');
        temp=temp.replace(',',' ');

        StringTokenizer st = new StringTokenizer(temp);
        String reversename=null;
        while (st.hasMoreTokens()) {
            if (reversename==null)
                reversename=st.nextToken();
            else
               reversename=reversename+","+st.nextToken();
       }

       if (reversename.indexOf(',')>0)
           return("near(("+reversename+"),0)");
       else
            return reversename;
   }

///////////////////////////////////////////////////////
    public String getTableName()
    {
    	return "dc";
    }

}


