package search;
 // class COracleAdvancedParam

import javax.servlet.*;
import javax.servlet.http.*;

import java.util.*;

public class OracleAdvancedParam extends AdvancedParam
{

     public OracleAdvancedParam(HttpServletRequest request){
        super(request);
        formalize();

	    boolean first = true;

        String linkoperator=null;

    	if ( and_or)
            linkoperator=" and ";
        else
            linkoperator=" or ";


    if ((creator!=null)&& (!creator.trim().equals(""))) {
		whereClause = "where contains(creator, '"+  creator+ "',1)>0";
        rankitem=" score(1) ";
		first = false;
    }


    if ((title!=null)&&(! title.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains (title, '"+ title+"',2)>0";
                    rankitem=" score(2) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator + "contains (title, '"+ title+"',2)>0";
		}
    }



    if ((description!=null)&&(!description.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(description, '"+ description+"', 3)>0";
                    rankitem=" score(3) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator + "contains(description, '"+ description+"', 3)>0";
		}
    }


    if ((archive!=null)&&(! archive.trim().equals("All")) && (! archive.trim().equals(""))) {
		if (first) {
		    whereClause = "where archive ='"+ archive+"'";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +" archive = '"+ archive+"'";
		}
    }

                
    if (( sets!=null)&&(! sets.trim().equals("All")) && (! sets.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains (sets, '"+ sets+"',4)>0";
                    rankitem=" score(4) ";
		    first = false;
		}
        else {
		    whereClause = whereClause+ linkoperator +"contains (sets, '"+ sets+"',4)>0";
		}
    }


    if ((publisher!=null)&&( !publisher.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(publisher, '"+ publisher+"',5)>0";
                    rankitem=" score(5) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(publisher, '"+ publisher+"',5)>0";
		}
    }

    if ((contributor!=null)&&(!contributor.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(contributor, '"+ contributor+"',6)>0";
                    rankitem=" score(6) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(contributor, '"+ contributor+"',6)>0";
		}
    }


    if ((type!=null)&&(!type.trim().equals("All"))&&(!type.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(type, '"+ type+"',7)>0";
                    rankitem=" score(7) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(type, '"+ type+"',7)>0";
		}
    }


    if ((format!=null)&&(!format.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(format, '"+ format+"',8)>0";
                    rankitem=" score(8) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(format, '"+ format+"',8)>0";
		}
    }


    if ((source!=null)&&(! source.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(source, '"+ source+"',9)>0";
                    rankitem=" score(9) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(source, '"+ source+"',9)>0";
		}
    }



    if ((language!=null)&&(!language.trim().equals("All")) &&(! language.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(language, '"+ language+"',10)>0";
                    rankitem=" score(10) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(language, '"+ language+"',10)>0";
		}
    }



    if ((relation!=null)&&(! relation.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(relation, '"+ relation+"',11)>0";
            rankitem=" score(11) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(relation, '"+ relation+"',11)>0";
		}
    }


        if((coverage!=null)&& (!coverage.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(coverage, '"+ coverage+"',12)>0";
                    rankitem=" score(12) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(coverage, '"+ coverage+"',12)>0";
		}
    }



        if ((rights!=null)&&(! rights.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains(rights, '"+ rights+"',13)>0";
                    rankitem=" score(13) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+ linkoperator +"contains(rights, '"+ rights+"',13)>0";
		}
    }


    if (( subject!=null)&&(! subject.trim().equals(""))&&(! subject.trim().equals("All"))) {
		if (first) {
		    whereClause = "where contains (subject,'"+ subject+"',14)>0";
            rankitem=" score(14) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+linkoperator+ " contains (subject,'"+ subject+"',14)>0";
		}
    }


    if ((datestamp!=null)&&(!datestamp.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains (datestamp, '"+ datestamp+"',15)>0";
                    rankitem=" score(15) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+linkoperator+ " contains (datestamp, '"+ datestamp+"',15)>0";
		}
    }



    if ((discovery!=null)&&(!discovery.trim().equals(""))) {
		if (first) {
		    whereClause = "where contains (discovery, '"+ discovery+"',16)>0";
                    rankitem=" score(16) ";
		    first = false;
		}
		else {
		    whereClause = whereClause+linkoperator + "contains (discovery, '"+ discovery+"',16)>0";
		}
    }

        if (sort.equals("discoverydate"))
            sortClause=" order by normdiscovery desc";
        else  if (sort.equals("archive"))
            sortClause=" order by archive asc";
        else if ((sort.equals("rank"))&& (rankitem!=null))
            sortClause=" order by "+ rankitem+" desc";
        else
            sortClause="";
	if (group.indexOf ("discovery")>-1)
			{
				group = "substr (normdiscovery,0,4)";
			}
        groupClause= " "+group+" ";

    }



}


